<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>RecordWriter.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">Code Coverage for Zookeeper manuall provided Classes</a> &gt; <a href="index.source.html" class="el_package">org.apache.jute</a> &gt; <span class="el_source">RecordWriter.java</span></div><h1>RecordWriter.java</h1><pre class="source lang-java linenums">/**
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * &quot;License&quot;); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an &quot;AS IS&quot; BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.jute;

import java.io.DataOutputStream;
import java.io.IOException;
import java.io.OutputStream;
import java.io.UnsupportedEncodingException;
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import java.util.HashMap;

/**
 * Front-end for serializers. Also serves as a factory for serializers.
 *
 */
public class RecordWriter {
    
    private OutputArchive archive;
    
    static private OutputArchive getBinaryArchive(OutputStream out) {
<span class="nc" id="L38">        return new BinaryOutputArchive(new DataOutputStream(out));</span>
    }
    
    static private OutputArchive getCsvArchive(OutputStream out)
    throws IOException {
        try {
<span class="nc" id="L44">            return new CsvOutputArchive(out);</span>
<span class="nc" id="L45">        } catch (UnsupportedEncodingException ex) {</span>
<span class="nc" id="L46">            throw new IOException(&quot;Unsupported encoding UTF-8&quot;);</span>
        }
    }
    
    static private OutputArchive getXmlArchive(OutputStream out)
    throws IOException {
<span class="nc" id="L52">        return new XmlOutputArchive(out);</span>
    }

    static HashMap constructFactory() {
<span class="nc" id="L56">        HashMap factory = new HashMap();</span>
<span class="nc" id="L57">        Class[] params = { OutputStream.class };</span>
        try {
<span class="nc" id="L59">            factory.put(&quot;binary&quot;,</span>
<span class="nc" id="L60">                    BinaryOutputArchive.class.getDeclaredMethod(</span>
                        &quot;getArchive&quot;, params));
<span class="nc" id="L62">            factory.put(&quot;csv&quot;,</span>
<span class="nc" id="L63">                    CsvOutputArchive.class.getDeclaredMethod(</span>
                        &quot;getArchive&quot;, params));
<span class="nc" id="L65">            factory.put(&quot;xml&quot;,</span>
<span class="nc" id="L66">                    XmlOutputArchive.class.getDeclaredMethod(</span>
                        &quot;getArchive&quot;, params));
<span class="nc" id="L68">        } catch (SecurityException ex) {</span>
<span class="nc" id="L69">            ex.printStackTrace();</span>
<span class="nc" id="L70">        } catch (NoSuchMethodException ex) {</span>
<span class="nc" id="L71">            ex.printStackTrace();</span>
<span class="nc" id="L72">        }</span>
<span class="nc" id="L73">        return factory;</span>
    }
    
<span class="nc" id="L76">    static private HashMap archiveFactory = constructFactory();</span>
    
    static private OutputArchive createArchive(OutputStream out,
            String format)
            throws IOException {
<span class="nc" id="L81">        Method factory = (Method) archiveFactory.get(format);</span>
<span class="nc bnc" id="L82" title="All 2 branches missed.">        if (factory != null) {</span>
<span class="nc" id="L83">            Object[] params = { out };</span>
            try {
<span class="nc" id="L85">                return (OutputArchive) factory.invoke(null, params);</span>
<span class="nc" id="L86">            } catch (IllegalArgumentException ex) {</span>
<span class="nc" id="L87">                ex.printStackTrace();</span>
<span class="nc" id="L88">            } catch (InvocationTargetException ex) {</span>
<span class="nc" id="L89">                ex.printStackTrace();</span>
<span class="nc" id="L90">            } catch (IllegalAccessException ex) {</span>
<span class="nc" id="L91">                ex.printStackTrace();</span>
<span class="nc" id="L92">            }</span>
        }
<span class="nc" id="L94">        return null;</span>
    }
    /**
     * Creates a new instance of RecordWriter
     * @param out Output stream where the records will be serialized
     * @param format Serialization format (&quot;binary&quot;, &quot;xml&quot;, or &quot;csv&quot;)
     */
    public RecordWriter(OutputStream out, String format)
<span class="nc" id="L102">    throws IOException {</span>
<span class="nc" id="L103">        archive = createArchive(out, format);</span>
<span class="nc" id="L104">    }</span>
    
    /**
     * Serialize a record
     * @param r record to be serialized
     */
    public void write(Record r) throws IOException {
<span class="nc" id="L111">        r.serialize(archive, &quot;&quot;);</span>
<span class="nc" id="L112">    }</span>
}
</pre><div class="footer"><span class="right">Created with <a href="http://www.eclemma.org/jacoco">JaCoCo</a> 0.7.7.201606060606</span></div></body></html>